/* -*- Mode: C++; indent-tabs-mode: nil; c-basic-offset: 2; tab-width: 2 -*- */
/***************************************************************************
 *            MediaServer.cpp
 * 
 *  FUPPES - Free UPnP Entertainment Service
 *
 *  Copyright (C) 2005-2011 Ulrich Völkel <u-voelkel@users.sourceforge.net>
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License version 2 as 
 *  published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */
 
#include "MediaServer.h"

MediaServer* MediaServer::m_instance = NULL;

void MediaServer::init(const std::string HTTPServerURL, const std::string uuid, IUPnPDevice* onTimerHandler) // static
{
  assert(m_instance == NULL);
  m_instance = new MediaServer(HTTPServerURL, uuid, onTimerHandler);
}

void MediaServer::uninit() // static
{
  assert(m_instance != NULL);
  delete m_instance;
  m_instance = NULL;
}

    

MediaServer::MediaServer(const std::string HTTPServerURL, const std::string uuid, IUPnPDevice* onTimerHandler)
:CUPnPDevice(UPNP_DEVICE_MEDIA_SERVER, HTTPServerURL, onTimerHandler)
{
  m_sUUID  			     = uuid;
  m_sPresentationURL = "index.html";      
}
