/* -*- Mode: C++; indent-tabs-mode: nil; c-basic-offset: 2; tab-width: 2 -*- */
/***************************************************************************
 *            PageDebug.cpp
 *
 *  FUPPES - Free UPnP Entertainment Service
 *
 *  Copyright (C) 2011 Ulrich Völkel <u-voelkel@users.sourceforge.net>
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#include "PageDebug.h"

//#include "../Common/Common.h"
#include "../Common/Thread.h"

using namespace fuppes;

std::string PageDebug::content()
{
  std::stringstream result;
  
  result << "<h1>threads</h1>";

  result << "<ul>";
  
  ThreadPool::lock();
  std::map<threadId_t, Thread*>* threads = ThreadPool::threads();

  std::map<threadId_t, Thread*>::iterator iter = threads->begin();
  for(; iter != threads->end(); iter++) {

    Thread* thread = iter->second;
    
    result << "<li>";

    result << thread->running() << " " << thread->finished() << " " << thread->name() << " " << thread->threadId();
    
    result << "</li>";
  }
  
  ThreadPool::unlock();

  result << "</ul>";
  
  return result.str();
}


